#ifndef ETHERNET_H
#define ETHERNET_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vector>
#include <iostream>

#define TimeVector std::vector<float>
#define SentVector std::vector<bool>
#define CollidedVector std::vector<bool>
#define ContIntVector std::vector<int>
#define ConflictVector std::vector<int>
#define COUT std::cout
#define ENDL std::endl

class Ethernet{
public:

	Ethernet(int lambda, int n);
	~Ethernet();
	
	void simulate();
	float getCI();
	
private:

	void dump();
	bool isEnded();
	void step();
	void retransmitSchedule();
	void send();

	float getRandom();
	ConflictVector getConflicts();

	TimeVector timeVector;
	SentVector sentVector;
	CollidedVector collidedVector;
	ContIntVector contIntVector;

	int n;
	int busy;
	int lambda;
	int sentItem;
};

#endif // ETHERNET_H
